# NextApp

A simple Next.js app to discover some awesome stuff !

## HOW TO guide

### Goals

Create a simple website with basic HTML and CSS.
And see how you can make your website portable, and how to deploy your application to the web easily.
Also you will see how we can automize the deployment process.

### Steps

**1. Clone the repository:**

```
git clone https://gitlab.com/polycloud_lab/flatsite.git <NAME_OF_YOUR_WEBSITE>
```

Open your new repository in your favorite IDE.

**2. Customize some HTML and CSS if wanted.**

Open the `src` folder and try to edit some files to customize your website.
See below how to run the application.

_if you are stuck at this point, use this magic command:_

```
git reset --hard step-1-website
```

**3. Make a Dockerfile to containerize the website.**

Now you want to make your application portable.
You will need to containerize your website. You can look at [this](https://www.docker.com/blog/how-to-use-the-official-nginx-docker-image/) guide to do it.

Don't forget to build the app before you can run it ;)

_if you are stuck at this point, use this magic command:_

```
git reset --hard step-2-container
```

**4. Make a GitLab-ci to deploy the app on CleverCloud.**

You now want to deploy the app on [CleverCloud](https://www.clever-cloud.com/fr/) (an awesome french cloud provider).
To automize this step, you want to deploy your application using [gitlab-ci](https://www.youtube.com/watch?v=ljth1Q5oJoo).

_if you are stuck at this point, use this magic command:_

```
git reset --hard step-3-gitlab-ci
```

## Getting started

First, run the development server:

```bash
npm run dev
# or
yarn dev
```

Open [http://localhost:3000](http://localhost:3000) with your browser to see the result.

You can start editing the page by modifying `pages/index.js`. The page auto-updates as you edit the file.

[API routes](https://nextjs.org/docs/api-routes/introduction) can be accessed on [http://localhost:3000/api/hello](http://localhost:3000/api/hello). This endpoint can be edited in `pages/api/hello.js`.

The `pages/api` directory is mapped to `/api/*`. Files in this directory are treated as [API routes](https://nextjs.org/docs/api-routes/introduction) instead of React pages.

## Learn More

To learn more about Next.js, take a look at the following resources:

- [Next.js Documentation](https://nextjs.org/docs) - learn about Next.js features and API.
- [Learn Next.js](https://nextjs.org/learn) - an interactive Next.js tutorial.

You can check out [the Next.js GitHub repository](https://github.com/vercel/next.js/) - your feedback and contributions are welcome!
